define("de_epages/saferpay2/ui/mbotransactions", [
    "jquery",
    "ep/ui/dialog",
    "ep/alert",
    "$ready!"
], function ($) {
    var Texts = {};

    function submitTransactionListForm() {
        document.forms["TransactionsList"].ChangeAction.value = "CaptureTransactions";
        document.forms["TransactionsList"].submit();
    }

    function buildDialogBox() {
        var dialogBox = $('.liabilityShiftDialog');
        var confirmLiabilityBox = ep(dialogBox).uiDialog({
            modal: true,
            title: Texts.WarningLiabilityShift,
            width: 700,
            buttons:
            [
                {
                    cssClass: 'ep-button ep-button-cancel',
                    text: Texts.Cancel,
                    click:function(){
                        ep(this).find("tr#transactionsCanbeCaptured").hide();
                        ep(this).find("tbody#LiabilityIdMessage").html("");
                        ep(this).uiDialog('close');
                    }
                },
                {
                    cssClass: 'ep-button ep-button-cta',
                    text: Texts.CaptureLiabilityShift,
                    click:function(){
                        submitTransactionListForm();
                    }
                }
            ]
        }).uiDialog('close');
        return confirmLiabilityBox;
    }

    function getTransactionsData() {
        var TransactionsData = {
            numberTransactions: 0,
            numberLiableTransactions: 0,
            numberNotLiableTransactions: 0,
            liableTransactionsId:[]
        };
        var TransactionList = $('input[name="ListObjectID"][data-authorized="1"]:checked');
        TransactionList.each(function(index, element){
            TransactionsData.numberTransactions++;

            var IsLiabilityShifted = parseInt(element.getAttribute('data-liability-shifted'));
            var TransactionId = element.getAttribute('data-transaction-id');

            if (IsLiabilityShifted) {
                TransactionsData.numberNotLiableTransactions++;
            } else {
                TransactionsData.numberLiableTransactions++;
                TransactionsData.liableTransactionsId.push(element.getAttribute('data-transaction-id'));
            }
        });
        return TransactionsData;
    }

    function assembleOpenDialog(confirmLiabilityBox, TransactionsData) {
        if (TransactionsData.numberNotLiableTransactions) {
            var NotLiableMessage = (
                TransactionsData.numberNotLiableTransactions + " "
                + (TransactionsData.numberNotLiableTransactions > 1 ?
                    Texts.TransactionsCanbeCapturedPlural : Texts.TransactionsCanbeCapturedSingular
                )
            );
            confirmLiabilityBox.find("td#message_transactionsCanbeCaptured").text(NotLiableMessage);
            confirmLiabilityBox.find("tr#transactionsCanbeCaptured").show();
        }

        var LiabilityMessage = (TransactionsData.numberLiableTransactions + " "
            + (TransactionsData.numberLiableTransactions > 1 ?
                Texts.TransactionsToConfirmLiabilityPlural : Texts.TransactionsToConfirmLiabilitySingular
            )
        );
        confirmLiabilityBox.find("td#message_transactionstoConfirmLiability").text(LiabilityMessage);

        var row = '<tr><td colspan="2"></td></tr>';
        TransactionsData.liableTransactionsId.forEach(function(element, index) {
            row += '<tr><td></td><td>' + Texts.TransactionNumber + ' "' + element + '"</td></tr>';
        });
        confirmLiabilityBox.find("tbody#LiabilityIdMessage").html(row);

        confirmLiabilityBox.uiDialog('open');
    }

    return function(
        CaptureButton,
        TranslatedTexts
    ) {
        Texts = TranslatedTexts;

        var confirmLiabilityBox = buildDialogBox();
        CaptureButton.on('click.checkLiabilityShift', function(event) {
            event.stopPropagation();
            event.preventDefault();
            if ($('input[value="CaptureTransactions"]')[0].disabled) {
                return true;
            }
            var TransactionsData = getTransactionsData();
            if (TransactionsData.numberLiableTransactions) {
                assembleOpenDialog(confirmLiabilityBox, TransactionsData);
                return false;
            }
            submitTransactionListForm();
            return true;
        });
    };
});
